#include "standards.h"
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>

#include "check_close.h"

type_status check_close(type_fd fd) {
  type_error saved_errno=errno;
  if (fcntl(fd, F_GETFD, 0)<0) return -1;
  while (close(fd)<0) {
    if (errno==EBADF) return 0;
    if (errno!=EINTR) return -1;
  }
  errno=saved_errno;
  return 0;
}
