(define /package/prog/prjlibs/load/1
  (let ((loaded-libs (make-hash-table 127))
        (load-module (current-module))
        (load-sym '/package/prog/prjlibs/load))
    (define* (/package/prog/prjlibs/load/1
              path #:optional (imports '()) (preloads '()))
      (let* ((handle (hash-create-handle! loaded-libs path #f))
             (callee (cdr handle))
             (caller (current-module)))
        (define (preload obj)
          (if (symbol? obj)
            (module-define! (current-module) obj       (module-ref caller obj))
            (module-define! (current-module) (car obj) (cadr obj))))
        (define (import obj)
           (if (symbol? obj)
             (module-define! caller obj       (module-ref callee obj))
             (module-define! caller (car obj) (module-ref callee (cadr obj)))))
        (if (not callee)
          (let ((old-hook %load-hook))
            (define (set-preloads filename)
              (set! %load-hook old-hook)
              (for-each preload
                        `((,load-sym ,(module-ref load-module load-sym))
                          . preloads))
              (module-modified (current-module))
              (if old-hook
                (old-hook filename)))
            (set! callee (make-module 0 `(,(resolve-interface '(guile)))))
            (set-module-name! callee `(,(string->symbol path)))
            (call-with-module-autoload-lock
             (lambda ()
               (nested-define-module! (resolve-module '() #f) name callee)))
            (save-module-excursion
             (lambda ()
               (set-current-module callee)
               (set! %load-hook set-preloads)
               (primitive-load path)))
            (set-cdr! handle callee)))
        (for-each import imports)
        (module-modified caller)
        (let ((new-module (make-module 0)))
          (define (copy-var sym var)
            (if (or (eq? sym load-sym)
                    (not (variable-bound? var)))
              #f
              (module-define! new-module sym (variable-ref var))))
          (module-for-each copy-var callee)
          (set-module-name! new-module (module-name callee))
          new-module)))
    /package/prog/prjlibs/load/1))

(define-syntax-rule (/package/prog/prjlibs/load path . rest)
  "\
If PATH has not yet been loaded, a new module is created, and the PRELOADS
and the file PATH are loaded into it.  IMPORTS are extracted from PATH's
module into the current module, and a copy of PATH's module is returned."
  (eval-when (expand load eval)
    (/package/prog/prjlibs/load/1 path . rest)))
